// HTML --> JavaScript
// http://www.accessify.com/tools-and-wizards/developer-tools/html-javascript-convertor/

// sidebar

//------------------------  

window.sidebarLoader = function(e, elm)
{
  // tato funkce vygeneruje položky jednoho sloupce menu nebo filteru
  function addMenuEntries(entry)
  {
    // přidání separatoru
    if (entry.id == "SEPARATOR")
      return "    <li class=\"li_separator\"><\/li>";

    // přidání checkboxu
    translations["_" + entry.id + "_title"] = entry.title;   
    var title = ' title="' + tr("_" + entry.id + "_title") + '"';

    translations["_" + entry.id] = entry.label;
    var text = tr("_" + entry.id);
    
    var className = entry.className ? (' class="' + entry.className + '"') : "";
    var style = entry.style ? (' style="' + entry.style + '"') : "";

    // přidání buttonu
    if (className.indexOf("button") != -1)
      return '    <li' + title + className + style + ' id=' + entry.id + '_button><span>' + text + '</span></li>';
    
    return '    <li' + title + className + style + '><input type=checkbox id=' + entry.id + '_checkbox><span>' + text + '</span></li>';
  }

  //########################################################################################
  // menu sidebar

  // ================================================================================
  //                             levá strana Menu
  // ================================================================================

  var menu_sidebar_html="";
  menu_sidebar_html += "<div class=\"sidebar\" id=\"map_sidebar\" style=\"display: none\">";

  menu_sidebar_html += "  <div class=\"sidebar_checkboxes\">";

  // položky levé částiy menu
  // -- jakákoli položka, např. "xxx" by měla obecně mít nastavené setting.display_xxx + asociované toggleSetting, kde se porovnává setting == "xxx"
  var menuEntries =  
  [
    //{id: "refresh", className: "button GSAK_Only", style: ((window.isGSAK && JAK.Browser.embedded) ? "" : "display: none;"),
    //    label: {"Czech": "Refresh", "English": "Refresh"},
    //    title: {"Czech": "", "English": ""}},
    
    {id: "load_file", className: "button", 
        label: {"Czech": "Otevřít GPX/KML/..", "English": "Load GPX/KML/.."}, 
        title: {"Czech": "Otevře a zobrazí soubor. Podporované formáty: GPX, KML, WPT, PLT + linie/polygony GSAKu a Geogetu.", "English": "Opens and displays a file. Supported formats: GPX, KML, WPT, PLT + GSAK and Geoget lines/polygons."}},
        
    {id: "SEPARATOR"},
    
    {id: "animation", style: "display:none;",    /* skryto, potřebujeme ale aby to existovalo, protože se toggleSettings odkazuje i na tento checkbox */
        label: {"Czech": "Animace rodiny", "English": "Animate family"},
        title: {"Czech": "Po najetí myší na bod animuje všechny body patřící do rodiny. Zkratka: SHIFT + A (jako Animace)", "English": "Animates all points within a family. Shortcut: SHIFT + A (like Animation)"}},  
        
    //{id: "reset_settings",                      /* neaktivní, nefunkční */
    //    label: {"Czech": "Reset nastavení", "English": "Reset settings"},
    //    title: {"Czech": "Resetuje nastavení při příštím startu mapy. Zkratka: SHIFT+Q", "English": "Reset map settings on next start. Shortcut: SHIFT+Q"}},
    
    {id: "bubble",
        label: {"Czech": "Názvy kešek", "English": "Cache labels"},
        title: {"Czech": "Zobrazí na mapě u všech kešek názvy. Lze dočasně vypnout nebo zapnout pomocí SHIFT. Zkratka: Y", "English": "Displays labels of all caches on the map. Can be temporarily (de)activated using SHIFT. Shortcut: Y"}},
        
    {id: "circles", 
        label: {"Czech": "Kolizní kruhy 161m", "English": "Collision circles"}, 
        title: {"Czech": "Zobrazí kolizní kruhy 161 m u všech fyzických bodů (tradiční kešky, finální body a fyzické stage). Zkratka: R (jako Rádius)", "English": "Displays collision circles 161 m (0.1 mile) around all physical caches (Traditional Cache, Final Location, Physical Stage). Shortcut: R (like Radius)"}},
    
    {id: "spider", 
        label: {"Czech": "Spojnice od rodiče", "English": "Lines from parent"}, 
        title: {"Czech": "Po najetí na bod zobrazí spojnice od rodiče (hlavního bodu kešky) ke všem dětem (child waypointům). Zkratka: L (jako Linie)",  "English": "Displays lines from parent to children on hovering over any point in the family. Shortcut: L (like Line)"}},
    
    {id: "mark_userflagged_parents", className: "GSAK_Only", 
        label: {"Czech": "Zvýraznit označené (rodiče)", "English": "Highlight flagged (parents)"}, 
        title: {"Czech": "Zobrazí červený ovál kolem kešek, které jsou označené v GSAKu (včetně všech jejich dětí).", "English": "Highlights points flagged within GSAK (and all their children) with a red ellipse."}},
    
    {id: "mark_userflagged_children", className: "GSAK_Only", 
        label: {"Czech": "Zvýraznit označené (děti)", "English": "Highlight flagged (children)"}, 
        title: {"Czech": "Zobrazí žlutý ovál kolem označených Child Waypointů.", "English": "Hightlighs flagged Child Waypoints with a yellow ellipse."}},
    
    {id: "search_field", 
        label: {"Czech": "Pole pro vyhledávání", "English": "Search field"}, 
        title: {"Czech": "Zobrazí pole pro vyhledávání.", "English": "Display search field."}},
    
    {id: "coordinate_grid", 
        label: {"Czech": "Síť zeměpisných souřadnic", "English": "Coordinate grid"}, 
        title: {"Czech": "Zobrazí síť zeměpisných souřadnic.", "English": "Display coordinate grid."}},
    
    {id: "coordinate_grid_sjtsk", 
        label: {"Czech": "Síť S-JTSK souřadnic", "English": "S-JTSK coordinate grid"}, 
        title: {"Czech": "Zobrazí síť S-JTSK souřadnic.", "English": "Display S-JTSK coordinate grid."}},
    
    {id: "scale", 
        label: {"Czech": "Měřítko mapy", "English": "Map scale"}, 
        title: {"Czech": "Zobrazí měřítko mapy. Pouze Mapy.cz a ZM10.", "English": "Displays map scale. Only Mapy.cz and ZM10."}},
    
    {id: "overview_map", 
        label: {"Czech": "Náhledová mapa ČR", "English": "Overview map (CZ)"}, 
        title: {"Czech": "Zobrazí neklikatelnou náhledovou mapku ČR. Při zapnutí minimapy je automaticky skrytá.", "English": "Displays unclickable overview map of the Czech Republic. Hidden while minimap is active."}},
    
    {id: "coordinates_box", 
        label: {"Czech": "Zobrazit souřadnice", "English": "Coordinates window"}, 
        title: {"Czech": "Zobrazí okno se souřadnicemi, na kterých se právě nachází myš.", "English": "Display window with coordinates under the mouse cursor."}},
    
    {id: "poi_base", style: (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? "display:none;" : "",    // turn off POI for IE <= 9
        label: {"Czech": "POI základní", "English": "POI base"},
        title: {"Czech": "Body zájmu (základní)", "English": "Points of interest (base)"}},
    
    {id: "poi_tourist", style: (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? "display:none;" : "", // turn off POI for IE <= 9
        label: {"Czech": "POI turistické", "English": "POI tourist"},
        title: {"Czech": "Body zájmu (turistické)", "English": "Points of interest (touristic)"}},
  ];
  
  menuEntries.forEach(function(entry)
  {
    menu_sidebar_html += addMenuEntries(entry);
  });

  // ** separator **
  // -- originally (one column): menu_sidebar_html += "    <li class=\"li_separator\"><\/li>";
  menu_sidebar_html += "  <\/div>";

  // ================================================================================
  //                           pravá strana Menu (mapové vrstvy)
  // ================================================================================

  menu_sidebar_html += "  <div class=\"sidebar_checkboxes\" style=\"border-left: 2px solid black; border-radius: 0px;\">";
    
  // ******
  // mapové vrstvy v pravé části menu
  // -- každá vrstva, např. "xxx" by měla mít položku ve window.transparentLayers + stejně pojmenované záznamy v settings.tl
  var layerEntries =              
  [
    {id: "trail", 
        label: {"Czech": "Turistické trasy", "English": "Trail"}, 
        title: {"Czech": "", "English": ""}},

    {id: "bike", 
        label: {"Czech": "Cyklotrasy", "English": "Bike"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "hybrid", 
        label: {"Czech": "Hybrid", "English": "Hybrid"}, 
        title: {"Czech": "", "English": ""}},

    {id: "g_hybrid", 
        label: {"Czech": "Google Hybrid", "English": "Google Hybrid"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "relief", 
        label: {"Czech": "Reliéf (ČR / Evropa)", "English": "Relief (Europe)"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "relief2", 
        label: {"Czech": "Reliéf (ČR)", "English": "Relief (CZ)"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "g_terrain", 
        label: {"Czech": "Reliéf (svět)", "English": "Relief"}, 
        title: {"Czech": "", "English": ""}},

    {id: "ortofoto", 
        label: {"Czech": "Ortofoto", "English": "Ortophoto"}, 
        title: {"Czech": "", "English": ""}},

    {id: "g_ortofoto", 
        label: {"Czech": "Ortofoto", "English": "Ortophoto"}, 
        title: {"Czech": "", "English": ""}},

    {id: "vrstevnice", 
        label: {"Czech": "Vrstevnice", "English": "Contour Lines"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "katastr", 
        label: {"Czech": "Katastrální mapa", "English": "Cadaster map (CZ)"}, 
        title: {"Czech": "Pro zobrazení informací o objektu či parcele, klikněte na dané místo pravým tlačítkem a pak použijte volbu 'Otevřít stránku v katastru'.", "English": "Works only within the Czech Republic. For showing extended information about a place, use context menu."}},

    {id: "def_body_budov", 
        label: {"Czech": "Definiční body budov", "English": "Definition points of buildings (CZ)"}, 
        title: {"Czech": "", "English": "Czech Republic only"}},

    {id: "def_body_parcel", 
        label: {"Czech": "Definiční body parcel", "English": "Definition points of parcels (CZ)"}, 
        title: {"Czech": "", "English": "Czech Republic only"}},

    {id: "bodova_pole", 
        label: {"Czech": "Bodová pole", "English": "Geodetic points"}, 
        title: {"Czech": "", "English": "Czech Republic only"}},

    {id: "boundaries", 
        label: {"Czech": "Správní hranice", "English": "Boundaries"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "morf", 
        label: {"Czech": "Geomorfologické celky", "English": "Geomorfology"}, 
        title: {"Czech": "", "English": "CZ only"}},

    {id: "g_streetview", 
        label: {"Czech": "Street View", "English": "Street View"}, 
        title: {"Czech": "Zobrazí vrstvu ukazující dostupnost Street View. Pro zobrazení Street View samotného použijte pravé tlačítko na požadovaném místě.", "English": "Displays Street View availability. For showing the actual Street View window, use context menu."}},

    {id: "pano", 
        label: {"Czech": "Seznam Panorama", "English": "Seznam Panorama"}, 
        title: {"Czech": "Zobrazí vrstvu ukazující dostupnost Seznam Panorama. Pro otevření Seznam Panorama samotného použijte pravé tlačítko na požadovaném místě.", "English": "Displays Seznam Panorama availability. For opening the actual Seznam Panorama window, use context menu."}},
        
    {id: "geocaches", 
        label: {"Czech": "Kešky", "English": "Geocaches"}, 
        title: {"Czech": "Kešky nejsou klikatelné!", "English": "Caches are not clickable!"}},
  
  ];
  
  layerEntries.forEach(function(entry)
  {
    menu_sidebar_html += addMenuEntries(entry);
  });  

  menu_sidebar_html += "  <\/div>";
  menu_sidebar_html += "<\/div>";

  var menu_sidebar = document.createElement("div");
  menu_sidebar.innerHTML = menu_sidebar_html;
  menu_sidebar = menu_sidebar.firstChild;
  
  // turn off right border for rightmost div
  menu_sidebar.lastChild.style.borderRight = "none";
    
  //var menu_sidebar = document.getElementById("map_sidebar");

  // ================================================================================
  //                                      init Menu
  // ================================================================================

  function initMenuSidebar()
  {
    sidebars_div.appendChild(menu_sidebar);

    // při otevření menu zaklikneme checkboxy v levé části Menu
    // -- ale jen tehdy, pokud existuje pro danou položku proměnná settings.display_něco
    menuEntries.forEach(function(entry)
    {
      var settingName = "display_" + entry.id;

      if (settingName in settings)
         document.getElementById(entry.id + "_checkbox").checked = settings[settingName];
    });
    
    // pro krátké bubliny nad keškami není záznam v settings, nastavíme manuálně
    document.getElementById("bubble_checkbox").checked = contains_class(mapadiv, "marker_bubble");
    
    // nastavíme tlačítka u transparentních vrstev
    for (transp in transparentLayers)
    {
      var val = settings.transparent_layers[settings.map][transp];
      var checkbox = document.getElementById(transp + "_checkbox");
      checkbox.parentNode.style.display = (typeof val === 'undefined') ? "none" : "";
      checkbox.checked = val;
    }
  }
  
  // handle checkboxes of both menu and filter sidebars
  function runLI(target)
  {
    // get LI
    if (target.parentNode.tagName.toLowerCase() == "li")
      target = target.parentNode;
    
    // filter out non-LI elements or empty LI (separator)  
    if (target.tagName.toLowerCase() != "li" || !target.firstChild)
      return;
    
    if (target.id == "refresh_button")
    {
      window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ.gsk";
      //window.location.href = "gsak://%FF/macro:silent/HTML_Custom_MapyCZ\\Update_Database.gsk?refresh/" + cachecode;
      //window.location.href = "gsak://%FF/refreshbrowser";
      return;
    }
    
    if (target.id == "load_file_button")
    {
      loadFile("fileInput2", target);
      return;
    }    

    if (target.firstChild.tagName.toLowerCase() == "input" && target.firstChild.type == "checkbox")
    {
      toggleSetting(target.firstChild.id.match(/^(\w+)_checkbox/)[1], "toggle");

      // send signal (for minimap.js)
      m.getSignals().makeEvent("sidebar-checkbox-change");
    }
  }

  function handleClickOnMenuSidebar(e, target)
  {
    runLI(target);
  }  
  
  function showMenuSidebar()
  {
    menu_sidebar.style.display = "block";  
  }  
  
  function hideMenuSidebar()
  {
    menu_sidebar.style.display = "";  
  }

  /**** handlery ****/
  EventUtil.addHandler(sidebar_button, "click", showMenuSidebar);
  EventUtil.addMouseHandler(menu_sidebar, "mouseleave", hideMenuSidebar);
  EventUtil.addHandler(menu_sidebar, "click", handleClickOnMenuSidebar);

  initMenuSidebar();

  // pokud jsme při prvním spuštění klikli na Menu, tak ho rovnou zobrazíme
  if (EventUtil.getTarget(e).id == "map_sidebar_button")
    showMenuSidebar();

  // ================================================================================
  //                              levá strana Filteru
  // ================================================================================
    
  var filter_siderbar_html="";
  filter_siderbar_html += "<div class=\"sidebar\" id=\"filter_sidebar\" style=\"display: none\">";  
  filter_siderbar_html += "  <ul class=\"sidebar_checkboxes\">";

  var filterSidebarEntries =              
  [
    {id: "hide_children",
        label: {"Czech": "Skrýt děti", "English": "Hide Children"},
        title: {"Czech": "Skryje všechny děti (Child Waypoints). Klávesová zkratka: C (jako Children)", "English": "Hides all Child Waypoints of all caches. Shortcut: C (like Children)"}},

    {id: "hide_parents",
        label: {"Czech": "Skrýt rodiče", "English": "Hide Parents"},
        title: {"Czech": "Skryje všechny rodiče (tedy hlavní body, děti nechá zobrazené). Klávesová zkratka: P (jako Parents)", "English": "Hides all parents (in other words - show only Child Waypoints). Shortcut: P (like Parents)"}},

    {id: "hide_all",
        label: {"Czech": "Skrýt vše", "English": "Hide All"},
        title: {"Czech": "Skryje úplně všechny keše a všechny jejich body. Pokud při skrytí máte myš na nějaké kešce, takto jediná a všechny její děti zůstanou zobrazeny. Klávesová zkratka: X (jako eXit)", "English": "Hides all caches and their children. When turning this on, if a mouse is over a cache, this one and only cache and its entire family stay displayed. Shortcut: X (like eXit)"}},

    {id: "hide_finals_family",
        label: {"Czech": "Zobrazit jen finálky", "English": "Show Finals only"},
        title: {"Czech": "U bodů, které mají Final Location nebo mají Corrected Coordinates, se zobrazí jen finálka a/nebo Corrected Coordinates.", "English": "Display only Final Location or Corrected Coordinates for each point when that point has either."}},

    {id: "private_hide", className: "GSAK_Only",
        label: {"Czech": "Speciální mód", "English": "Special mode"},
        title: {"Czech": "Speciální mód. Pokud je keška nalezena, tak to zobrazí jen ty děti, které jsou označené. Pokud keška není nalezena, tak to naopak zobrazí jen ty děti, které nejsou označené. Parkovací body to zobrazí jen pokud jsou explicitně označené (bez ohledu na stav nalezení). Klávesová zkratka: CTRL+ALT+SHIFT+P", "English": "Hides non-flagged children of found caches and flagged children of non-found caches. Parking waypoints are hidden irregardless of found status, unless explicitly flagged. Shortcut: CTRL+ALT+SHIFT+P"}},

    {id: "SEPARATOR"},

    {id: "hide_status_archived",
        label: {"Czech": "Skrýt archivované", "English": "Hide archived"},
        title: {"Czech": "Skryje všechny archivované kešky", "English": "Hides all archived caches"}},

    {id: "hide_status_disabled",
        label: {"Czech": "Skrýt disablované", "English": "Hide disabled"},
        title: {"Czech": "Skryje všechny disablované kešky", "English": "Hides all disabled caches"}},
    
    {id: "hide_status_found",
        label: {"Czech": "Skrýt nalezené", "English": "Hide found"},
        title: {"Czech": "Skryje všechny nalezené kešky", "English": "Hides all found caches"}},
    
    {id: "hide_status_owned",
        label: {"Czech": "Skrýt vlastněné", "English": "Hide owned"},
        title: {"Czech": "Skryje všechny vlastněné kešky", "English": "Hides all owned caches"}},
    
    {id: "hide_status_else",
        label: {"Czech": "Skrýt ostatní", "English": "Hide other"},
        title: {"Czech": "Skryje všechny kešky, které nejsou ani jedno z výše uvedeného (archivované, disablované, nalezené, vlastněné)", "English": "Hides all caches that are not in the list above (archived, disabled, found, owned)"}},

    {id: "SEPARATOR"},
    
    {id: "hide_flagged_parents", className: "GSAK_Only",
        label: {"Czech": "Skrýt označené (rodiče)", "English": "Hide flagged (parents)"},
        title: {"Czech": "Skryje všechny (v GSAKu) označené rodičovské body (včetně všech jejich dětí).", "English": "Hides all flagged parents (including all their Child Waypoints)."}},
    
    {id: "hide_flagged_children", className: "GSAK_Only",
        label: {"Czech": "Skrýt označené (děti)", "English": "Hide flagged (children)"},
        title: {"Czech": "Skryje všechny (v GSAKu) označené Child Waypointy.", "English": "Hides all flagged Child Waypoints."}},
    
    {id: "hide_selected",
        label: {"Czech": "Skrýt vybrané", "English": "Hide selected"},
        title: {"Czech": "Skryje vybrané body (více o nich viz Nápověda na pravém tlačítku).", "English": "Hides all selected points (more about them in the Help)."}},
  ];

  filterSidebarEntries.forEach(function(entry)
  {
    filter_siderbar_html += addMenuEntries(entry);
    //alert(addMenuEntries(entry));
  });

  // ================================================================================
  //                              pravá strana Filteru
  // ================================================================================
  
  translations["Cache Filter"] = {"Czech": "WP Filtr"},
  translations["_show_all"] = {"Czech": "Zobrazit vše", "English": "Show all"},
  translations["_hide_all"] = {"Czech": "Skrýt vše", "English": "Hide all"},

  filter_siderbar_html += "  <\/ul>";
  filter_siderbar_html += "";
  filter_siderbar_html += "  <div id=\"sidebar_cache_filter\">";
  filter_siderbar_html += "";
  filter_siderbar_html += "    <div id=\"cache_filter_header\">";
  filter_siderbar_html += "      <div id=\"cache_filter_label\">" + tr("Cache Filter") + "<\/div>";
  filter_siderbar_html += "      <div id=\"cache_filter_buttons\">";
  filter_siderbar_html += "        <div class=\"button\" id=\"cache_filter_show_all\">" + tr("_show_all") + "<\/div>";
  filter_siderbar_html += "        <div class=\"button\" id=\"cache_filter_hide_all\">" + tr("_hide_all") + "<\/div>";
  filter_siderbar_html += "      <\/div>";
  filter_siderbar_html += "    <\/div>";
  filter_siderbar_html += "";
  filter_siderbar_html += "    <div id=\"cache_filter_parents\">";
  
  // přidání klikatelných ikonek kešek
  ["T","M","U","B","R","I","",                               /* první řádek */
    "Y","W","V","E","Z","C","",                              /* druhý řádek */
    "L","O","A","G","X","F","",                              /* třetí řádek */
    "H","D","P","J",""].forEach(function(entry)              /* čtvrtý řádek */
  {
    // nový řádek
    if (entry == "")
      filter_siderbar_html += "      <div class=\"clear_both\"><\/div>";
    // přidání kešky
    else
      filter_siderbar_html += '      <div class="cacheimg_parent cacheimg_' + entry + '" data-cachetype=' + entry + '><\/div>';  
  })

  filter_siderbar_html += "    <\/div>";
  filter_siderbar_html += "    ";
  filter_siderbar_html += "    <div id=\"cache_filter_children\">";
  
  // přídání spodních ikonek child waypointů
  ["FinalLocation","ParkingArea","VirtualStage","PhysicalStage","Trailhead","ReferencePoint","Corrected"].forEach(function(entry)
  {
    filter_siderbar_html += '      <div class="cacheimg_child cacheimg_' + entry + '" data-cachetype="' + entry + '"><\/div>';
  })  

  filter_siderbar_html += "    <\/div>";
  filter_siderbar_html += "  <\/div>";
  filter_siderbar_html += "<\/div>";
  
  var filter_sidebar = document.createElement("div");
  filter_sidebar.innerHTML = filter_siderbar_html;
  filter_sidebar = filter_sidebar.firstChild;  
  //var filter_sidebar = document.getElementById("filter_sidebar");

  // ================================================================================
  //                                 init Filter
  // ================================================================================

  function initFilterSidebar()
  {
    sidebars_div.appendChild(filter_sidebar);
    
    // set checkboxes
    document.getElementById("hide_children_checkbox").checked = settings["hide_children_local"];
    document.getElementById("hide_parents_checkbox").checked = settings["hide_parents_local"];
    document.getElementById("hide_all_checkbox").checked = contains_class(mapadiv, "marker_hide");
    document.getElementById("hide_finals_family_checkbox").checked = settings["hide_finals_family"];
    document.getElementById("private_hide_checkbox").checked =  settings["private_hide"];
    document.getElementById("hide_status_archived_checkbox").checked = settings["hide_status_archived"];
    document.getElementById("hide_status_disabled_checkbox").checked = settings["hide_status_disabled"];
    document.getElementById("hide_status_found_checkbox").checked = settings["hide_status_found"];
    document.getElementById("hide_status_owned_checkbox").checked = settings["hide_status_owned"];
    document.getElementById("hide_status_else_checkbox").checked = settings["hide_status_else"];
    
    document.getElementById("hide_flagged_parents_checkbox").checked = settings["hide_flagged_parents"];
    document.getElementById("hide_flagged_children_checkbox").checked = settings["hide_flagged_children"];
    document.getElementById("hide_selected_checkbox").checked = settings["hide_selected"];

    /**** init cache filter with caches that are present ****/
    var nodes = document.querySelectorAll("#sidebar_cache_filter .cacheimg_parent, #sidebar_cache_filter .cacheimg_child");
    
    // get available cache types
    var cachetypes = {};
    
    for (var i in wp)
      cachetypes[wp[i].CacheType] = true;
          
    // parse and set sidebar DIVs (cache icons)
    for (var i = 0, len = nodes.length; i < len; i++)
    {
      var cachetype = nodes[i].getAttribute("data-cachetype");
      nodes[i].title = CacheNames[cachetype];
      add_class(nodes[i], cachetypes[cachetype] ? "active" : "disabled");
    }
  }
  
  function handleClickOnFilterSidebar(e, target)
  {
    // --- handle cache filter ---
    
    // handle click on cache icon
    var cachetype = target.getAttribute("data-cachetype");
    
    if (cachetype)
    {
      if (contains_class(target, "active")) 
        toggleSetting("disable_cache", target);
      else if (contains_class(target, "inactive")) 
        toggleSetting("enable_cache", target);
      else                                          
        return;
    }
    
    // handle show/hide all buttons
    if (target.id == "cache_filter_show_all" || target.id == "cache_filter_hide_all")
    {
      var nodes = document.querySelectorAll("#sidebar_cache_filter .cacheimg_parent, #sidebar_cache_filter .cacheimg_child");

      for (var i = 0, len = nodes.length; i < len; i++)
      {
        if (contains_class(nodes[i], "disabled"))
          continue;

        toggleSetting((target.id == "cache_filter_show_all") ? "enable_cache" : "disable_cache", nodes[i]);
      }    
    }
    
    // --- handle left menu ---
    runLI(target);  
  }
  
  initFilterSidebar();    
  
  function showFilterSidebar()
  {
    filter_sidebar.style.display = "block";  
  }
  
  function hideFilterSidebar()
  {
    filter_sidebar.style.display = "";  
  }

  /**** left click on button - show sidebar ****/
  EventUtil.addHandler(filter_button, "click", showFilterSidebar);  
  
  // pokud jsme při prvním spuštění klikli na tlačítko Filter, tak filter sidebar rovnou zobrazíme
  if (EventUtil.getTarget(e).id == "filter_sidebar_button")
    showFilterSidebar();
    
  /**** mouseout - hide sidebar ****/
  EventUtil.addMouseHandler(filter_sidebar, "mouseleave", hideFilterSidebar);
  
  /**** left click on sidebar ****/
  EventUtil.addHandler(filter_sidebar, "click", handleClickOnFilterSidebar);
};